using System.Numerics;
using Nethereum.ABI.FunctionEncoding.Attributes;
using Nethereum.Contracts;
using HexBigInteger = Nethereum.Hex.HexTypes.HexBigInteger;

namespace Frontend.Functions;
[Function("exactInputSingle", "uint256")]
public class SwapExactInputSingleFunction : FunctionMessage
{
    [Parameter("address", "tokenIn",1)]
    public string TokenIn { get; set; }

    [Parameter("address", "tokenOut",2)]
    public string TokenOut { get; set; }
    
    [Parameter("uint24", "fee",3)]
    public BigInteger Fee { get; set; }
    
    [Parameter("address", "recipient",4)]
    public string Recipient { get; set; }

    [Parameter("uint256", "amountIn",5)]
    public BigInteger AmountIn { get; set; }

    [Parameter("uint256", "amountOutMinimum",6)]
    public BigInteger AmountOutMinimum { get; set; }

    [Parameter("uint160", "sqrtPriceLimitX96",7)]
    public BigInteger SqrtPriceLimitX96 { get; set; }
}