using Frontend.Configuration;
using Nethereum.Contracts;
using Nethereum.Web3;
using Nethereum.Web3.Accounts;


namespace Frontend.Services;

public class PoolManager
{
    private readonly Web3 _web3;
    private readonly ILogger<PoolManager> _logger;
    private readonly ChainSettings _chainSettings;
    /***
    https://sepolia.etherscan.io/address/0x0227628f3F023bb0B980b67D528571c95c6DaC1c#readContract
    */
    public PoolManager(
        string apiUrl,
        Account account,
        ILogger<PoolManager> logger,
        ChainSettings chainSettings


    )
    {
        _logger = logger;
        _web3 = new(account, apiUrl);
        _chainSettings = chainSettings;
    }

    public Contract GetPoolV3(string tokenAAddress, string tokenBAddress, int percentage)
    {
        (tokenAAddress, tokenBAddress) = EnsureCorrectOrder(tokenAAddress, tokenBAddress);

        _logger.LogDebug("Retrieving pool for token {} and token {} with fee {}", tokenAAddress, tokenBAddress, percentage);
        var contract = _web3.Eth.GetContract(
            File.ReadAllText(Path.Combine(Directory.GetCurrentDirectory(), "Configuration", "Abi", _chainSettings.Uniswap.UniswapV3Factory + ".abi.json")),
            _chainSettings.Uniswap.UniswapV3Factory
            );

        return contract;

    }

    public Contract CreatePoolV3(string tokenAAddress, string tokenBAddress, int percentage)
    {
        (tokenAAddress, tokenBAddress) = EnsureCorrectOrder(tokenAAddress, tokenBAddress);
        /*   var factoryService = _web3.Eth.GetContract(factoryAbi,);
           var createPairFunction = factoryService.GetFunction("createPair");
   var createPairReceipt = await createPairFunction.SendTransactionAndWaitForReceiptAsync(yourAddress, new HexBigInteger(percentage), null, tokenA, tokenB);*/
        throw new NotImplementedException();
    }

    private (string, string) EnsureCorrectOrder(string tokenAAddress, string tokenBAddress)
    {
        if (String.Compare(tokenAAddress, tokenBAddress) > 0)
        {
            return (tokenBAddress, tokenAAddress);
        }
        return (tokenAAddress, tokenBAddress);
    }

}